function sngmbhSerialcodesValidator(_myAjaxVar){
	let myAjax = _myAjaxVar;
	let self = this;
	let PREMIUM = null;
	var $ = jQuery;
	var DATA = {
        /*action: '',*/
        nonce: myAjax.nonce
    };

	var FATAL_ERROR = false;
    var DIV = null;
    var LAYOUT = null;
    var DATA_LISTS = null;

	function _makePost(action, myData, cbf, ecbf) {
		if (FATAL_ERROR) return;
		let _data = Object.assign({}, DATA);
		_data.action = myAjax._action;
		_data.a = action;
		for(var key in myData) _data['data['+key+']'] = myData[key];
        $.post( myAjax.url, _data, function( response ) {
            if (!response.success) {
            	if (ecbf) ecbf(response);
            	else LAYOUT.renderFatalError(response.data);
            } else {
            	cbf && cbf(response.data);
            }
        });
	}

	function _makeGet(action, myData, cbf, ecbf) {
		if (FATAL_ERROR) return;
		let _data = Object.assign({}, DATA);
		_data.action = myAjax._action;
		_data.a = action;
		for(var key in myData) _data['data['+key+']'] = myData[key];
        $.get( myAjax.url, _data, function( response ) {
            if (!response.success) {
            	if (ecbf) ecbf(response);
            	else LAYOUT.renderFatalError(response.data);
            } else {
            	cbf && cbf(response.data);
            }
        });
	}

	function _requestURL(action, myData) {
		let paras = '?action='+myAjax._action+'&a='+action;
		for(let key in myData) paras += '&data['+key+']='+encodeURIComponent(myData[key]);
		for(let key in DATA) paras += '&'+key+'='+encodeURIComponent(DATA[key]);
		return myAjax.url + paras;
	}

	function getDataLists(cbf) {
		if (DATA_LISTS !== null) cbf && cbf();
		_makeGet('getLists', {}, function(data) {
			DATA_LISTS = data;
			cbf && cbf(DATA_LISTS);
		});
	}

	function generateCode(length, cases, withnumbers, exclusion) {
		let charset = 'abcdefghijklmnopqrstuvwxyz';
		if (cases === 1) charset = charset.toUpperCase();
		if (cases === 3) charset += charset.toUpperCase();
	    if (withnumbers) charset += '0123456789';
	    if (typeof exclusion !== "undefined") {
	    	exclusion.forEach(function(v){
	    		let regex = new RegExp(v, 'gi');
	    		charset = charset.replace(regex, "");
	    	});
	    }
	    let retVal = "";
	    for (var i = 0, n = charset.length; i < length; ++i) {
	        retVal += charset.charAt(Math.floor(Math.random() * n));
	    }
	    return retVal;
	}

	function insertSeperator(str, serial_delimiter, serial_delimiter_space) {
		if (str !== "" && serial_delimiter !== "" && serial_delimiter_space > 0) {
			let result = [str[0]];
			for(let x=1; x<str.length; x++) {
    			if (x%serial_delimiter_space === 0) {
      				result.push(serial_delimiter, str[x]);
     			} else {
      				result.push(str[x]);
     			}
  			}
			return result.join('');
		}
		return str;
	}

	function closeDialog(dlg) {
		$(dlg).dialog( "close" );
		$(dlg).html('');
		$(dlg).dialog("destroy").remove();
		$(dlg).empty();
		$(dlg).remove();
		$('.ui-dialog-content').dialog('destroy');
	}
	class Layout {
		constructor(){
			DIV.addClass("sngmbh_container").css("margin-right", "10px");
			this.div_liste = $('<div/>').html(_getSpinnerHTML());
			this.div_codes = $('<div/>').html(_getSpinnerHTML());
		}
		renderMainBody() {
			let div_body = $('<div/>');
			if (myAjax._isPremium) {
				div_body
					.append('<div style="color:green;font-weight:bold;">PREMIUM active</div>')
					.append(PREMIUM.displaySettingAreaButton());
			} else div_body.append('<div style="color:red;font-weight:bold;">FREE version</div>');
			div_body.append($('<h3/>').html("Lists of codes"));
			div_body.append($('<p/>').html("Organize your codes in lists. You can assign codes to a list."));
			div_body.append(this.div_liste);
			div_body.append($('<hr/>'));
			div_body.append($('<h3/>').html("Codes"));
			div_body.append(this.div_codes);
			return div_body;
		}
		renderAddCodes() {
			DIV.html(_getSpinnerHTML());
			function __createDivInput(label) {
				return $('<div/>').css({
					"display": "inline-block",
				    "margin-bottom": "15px",
				    "margin-right": "15px"
				}).html(label+"<br>");
			}
			getDataLists(function() {
				function __generateCodes() {
					// generate codes and
					let amount_codes = parseInt(input_amount_codes.val().trim(),10);
					if (isNaN(amount_codes) || amount_codes < 1) {
						input_amount_codes.select();
						return alert("Enter an amount of how many codes you need");
					}
					if (amount_codes > _maxCodes) {
						input_amount_codes.val(_maxCodes);
						amount_codes = _maxCodes;

					}
					let uniq = {};
					let versuche = 0;
					if (input_type_codes.val() === "2") { // numbers
						let start_number = parseInt(input_number_start.val().trim(),10);
						if (isNaN(start_number) || start_number < 1) {
							input_number_start.select();
							return alert("Your start number is not correct. It has to be an integer and start from 1");
						}
						let number_offset = parseInt(input_number_offset.val().trim(),10);
						if (isNaN(number_offset) || number_offset < 1) number_offset = 1;
						let code = start_number;
						for(let a=0; a < amount_codes; a++) {
							if (typeof uniq[code] !== "undefined") {
								continue;
							}
							uniq[code] = true;
							code += number_offset;
						}
						versuche = amount_codes;
					} else {
						let amount_letters = parseInt(input_amount_letters.val().trim(),10);
						if (isNaN(amount_letters) || amount_letters < 1) {
							input_amount_letters.select();
							return alert("Amount of letters has to be higher");
						}
						// erstmal kein check ob mit dem alphabet und die geforderte Menge an letters, unique codes erstellt werden können
						let exclusion = input_letter_excl.val() === "2" ? ['i','l','o','p','q'] : [];
						let letter_style = parseInt(input_letter_style.val(),10);
						let include_numbers = input_include_numbers.val() === "2";
						let serial_delimiter = ['','-',' ',':'][parseInt(input_serial_delimiter.val(),10)-1];
						let serial_delimiter_space = 0;
						try {
							serial_delimiter_space = serial_delimiter !== "" ? parseInt(input_serial_delimiter_space.val(),10) : 0;
						} catch (e) {}
						let counter = 0;
						let versuche_max = amount_codes * 1.5;
						while(counter < amount_codes && versuche < versuche_max) {
							versuche++;
							let code = generateCode(amount_letters, letter_style, include_numbers, exclusion);
							if (typeof uniq[code] !== "undefined") {
								continue;
							}
							code = insertSeperator(code, serial_delimiter, serial_delimiter_space);
							uniq[code] = true;
							counter++;
						}
					}
					return [Object.keys(uniq), versuche];
				} // __generateCodes

				let div = $('<div/>').append($('<button/>').addClass("button-primary").html("Back").css("margin-bottom", "10px").on("click", function(){
					LAYOUT.renderAdminPageLayout();
				}));
				// eingabe generator options
				let div_generator = $('<div/>').css("padding", "10px").css("border","1px solid black").html("<h3>Code generator</h3>").appendTo(div);
				// anzahl codes
				let div_amount_codes = __createDivInput("Enter amount of codes needed").appendTo(div_generator);
				let _maxCodes = myAjax._max.codes;
				if (!isPremium())	div_amount_codes.append(_maxCodes+' Max. '+getLabelPremiumOnly()+' up to 100.000<br>');
				let input_amount_codes = $('<input type="number" required value="100" min="1" max="'+_maxCodes+'">').appendTo(div_amount_codes);

				// type numbers/serials
				let div_type_codes = __createDivInput("Choose type of codes").appendTo(div_generator);
				let input_type_codes = $('<select><option value="1" selected>Serials</option><option value="2">Numbers</option></select>').appendTo(div_type_codes);
				input_type_codes.on("change", function() {
					if (input_type_codes.val() === "2") {
						div_serials.find("input").prop("disabled", true);
						div_serials.find("select").prop("disabled", true);
						div_numbers.find("input").prop("disabled", false);
						div_numbers.find("select").prop("disabled", false);
					} else {
						div_serials.find("input").prop("disabled", false);
						div_serials.find("select").prop("disabled", false);
						div_numbers.find("input").prop("disabled", true);
						div_numbers.find("select").prop("disabled", true);
					}
				});
				// if serials
				let div_serials = $('<div>').html('<h4>Serials options</h4>').appendTo(div_generator);
					// anzahl letters
					let div_amount_letters = __createDivInput("Amount of letter needed").appendTo(div_serials);
					let input_amount_letters = $('<input type="number" required value="9" min="1" max="30">').appendTo(div_amount_letters);
					input_amount_letters.on("change", function(){
						input_serial_delimiter.trigger("change");
					});
					// select letter exclusion
					let div_letter_excl = __createDivInput("Letter exclusion").appendTo(div_serials);
					let input_letter_excl = $('<select><option value="1">None</option><option value="2" selected>i,l,o,p,q</option></select>').appendTo(div_letter_excl);
					// radio button text gross/klein/both/none
					let div_letter_style = __createDivInput("Letter style").appendTo(div_serials);
					let input_letter_style = $('<select><option value="1" selected>Uppercase</option><option value="2">Lowercase</option><option value="3">Both</option></select>').appendTo(div_letter_style);
					// radio button numbers/none
					let div_include_numbers = __createDivInput("Numbers needed?").appendTo(div_serials);
					let input_include_numbers = $('<select><option value="1" selected>No</option><option value="2">Yes</option></select>').appendTo(div_include_numbers);
					// select delimiter none/-/./space
					let div_serial_delimiter = __createDivInput("Delimiter?").appendTo(div_serials);
					let input_serial_delimiter = $('<select><option value="1" selected>None</option><option value="2">-</option><option value="4">:</option><option value="3">Space</option></select>').appendTo(div_serial_delimiter);
					input_serial_delimiter.on("change", function(){
						input_serial_delimiter_space.html("");
						if (input_serial_delimiter.val() !== "1") {
							let anzahl = parseInt(input_amount_letters.val(),10);
							for(let a=1;a<anzahl-3;a++) input_serial_delimiter_space.append($('<option'+(anzahl > 2 && a === 3 ? " selected": "")+'>').attr("value",a).html(a));
						}
					});
					// choose delimiter space
					let div_serial_delimiter_space = __createDivInput("After how many letters?").appendTo(div_serials);
					let input_serial_delimiter_space = $('<select></select>').appendTo(div_serial_delimiter_space);
				// if numbers
				let div_numbers = $('<div/>').html('<h4>Numbers options</h4>').appendTo(div_generator);
					// number start
					let div_number_start = __createDivInput("Start number").appendTo(div_numbers);
					let input_number_start = $('<input type="number" disabled required value="10000" min="1">').appendTo(div_number_start);
					// number offset
					let div_number_offset = __createDivInput("Offset for each number").appendTo(div_numbers);
					let input_number_offset = $('<input type="number" disabled required value="1" min="1">').appendTo(div_number_offset);

				// button generate
				div_generator.append($('<button/>').addClass("button-secondary").html("Generate codes").on("click", function(){
					let time_start = performance.now();
					btn_store_codes.prop("disabled", false);
					input_textarea.prop("disabled", false);
					input_textarea.html("").prop("disabled", true);
					div_textarea_info.html(_getSpinnerHTML());
					setTimeout(function(){
						let r = __generateCodes();
						let codes = r[0];
						let secs = ((performance.now() - time_start) / 1000)+"";
						input_textarea.html(codes.join("\n"));
						input_textarea.prop("disabled", false);
						div_textarea_info.html('Created '+codes.length+' codes. In '+secs.slice(0,5)+' seconds, with '+r[1]+' runs to find unique codes');
					},250);
				}));

				// eingabe maske textarea
				let div_textarea = $('<div/>').html('<h3>Codes to store on the server</h3><p>One code per line. While storing the codes to the server, it will check if the code is unique and mark the codes, that are not.</p>').appendTo(div);
				let div_textarea_info = $('<div/>').appendTo(div_textarea);
				let input_textarea = $('<textarea>').css("height","135px").css("width","100%").appendTo(div_textarea);
				div_textarea.append("<br>");
				// list auswahl
				let div_code_list = __createDivInput("Assign to this code list").appendTo(div_textarea);
				let input_code_list = $('<select><option value="0">None</select></select>').appendTo(div_code_list);
				DATA_LISTS.forEach(v=>{
					input_code_list.append('<option value="'+v.id+'">'+v.name+'</option>');
				});
				div_textarea.append("<br>");
				// button store codes
				if (!isPremium()) div_textarea.append("<b>You can store up to "+myAjax._max.codes+'. '+getLabelPremiumOnly()+' unlimited<br>');
				let btn_store_codes = $('<button/>');
				btn_store_codes.addClass("button-primary").html("Store codes").on("click", function(){
					// extract codes and
					let codes = input_textarea.val().split("\n").map(x=>x.trim());
					if (codes.length === 0) return;

					// sperre btn store codes
					btn_store_codes.prop("disabled", true);
					input_textarea.prop("disabled", true);

					div_textarea_info.append($('<div/>').addClass("notice notice-info").html("Each entry will turn green (successfull stored) or red (not stored - duplicat entry on the server).<br>Scroll down and wait for all to finish.<br>In the textarea below you will find all the successful stored codes.<"));
					let _output = $('<ol/>').appendTo(div_textarea_info);
					div_textarea_info.append("<h3>Successfull stored codes</h3>");
					let output_textarea_codes_done = $('<textarea disabled style="width:100%;height:150px;"></textarea>').appendTo(div_textarea_info);

					let list_id = parseInt(input_code_list.val(),10);
					codes.forEach(v=>{
						if (FATAL_ERROR === false && v !== "") {
							// schreibe code in die info area
							let div_info_entry = $('<li/>').html(v);
							_output.append(div_info_entry);
							// send them one by one to the server
							setTimeout(function(){
								_makeGet("addCode", {"code":v, "list_id":list_id}, function(data){
									div_info_entry.css("color","green").append(" (OK)");
									output_textarea_codes_done.append(v+"\n");
								}, function(response){
									if (response.data.slice(0,4) === "#208") {
										FATAL_ERROR === false && LAYOUT.renderFatalError(response.data);
										FATAL_ERROR = true;
									}
									div_info_entry.css("color","red").append(" (NOT OK)");
								});
							}, 250);
						}
					});
					// zeige ok button, der info area leer macht und den btn store codes wieder aktiviert
					div_textarea_info.append($('<button/>').addClass("button-primary").css("margin-bottom", "20px").html("Ok").on("click", function(){
						div_textarea_info.html("");
						btn_store_codes.prop("disabled", false);
						input_textarea.prop("disabled", false);
					}));

				}).appendTo(div_textarea);
				DIV.html(div);
			});
		}
		renderAdminPageLayout() {
			function __showMaskList(editValues){
				let _options = {
					title: editValues !== null ? 'Edit List' : 'Add List',
			      	modal: true,
			      	minWidth: 400,
					minHeight: 200,
			      	buttons: [
			      		{
			      			text: "Ok",
			      			click: function() {
								___submitForm();
			      			}
			      		},
			      		{
			      			text: "Cancel",
			      			click: function() {
			      				closeDialog(this);
			      			}
			      		}
		      		]
			    };
			    let dlg = $('<div/>').html('<form>Name<br><input name="inputName" type="text" required></form>');
				dlg.dialog(_options);

				let form = dlg.find("form").on("submit", function(event) {
					event.preventDefault();
					___submitForm();
				});
				function ___submitForm() {
					let inputName = form[0].elements['inputName'].value.trim();
					if (inputName === "") return;
					dlg.html(_getSpinnerHTML());
					form[0].reset();
					let _data = {"name":inputName};
					if (editValues) {
						_data.id = editValues.id;
						_makePost('editList', _data, function(result) {
							DATA_LISTS = null;
							__renderTabelleListen();
							tabelle_codes_datatable.ajax.reload();
							setTimeout(function(){closeDialog(dlg);},250);
						}, function() {
							closeDialog(dlg);
						});
					} else {
						_makePost('addList', _data, function(result) {
							DATA_LISTS = null;
							__renderTabelleListen();
							closeDialog(dlg);
						}, function() {
							if (response.data.slice(0,4) === "#108") {
								FATAL_ERROR === false && LAYOUT.renderFatalError(response.data);
								FATAL_ERROR = true;
							}
							closeDialog(dlg);
						});
					}
				}

				if (editValues) {
					form[0].elements['inputName'].value = editValues.name;
					form[0].elements['inputName'].select();
				}
			} // ende showmaskliste

			function __showMaskCode(editValues){
				let _options = {
					title: editValues !== null ? 'Edit Code' : 'Add Code',
			      	modal: true,
			      	minWidth: 400,
					minHeight: 200,
			      	buttons: [
			      		{
			      			text: "Ok",
			      			click: function() {
								___submitForm();
			      			}
			      		},
			      		{
			      			text: "Cancel",
			      			click: function() {
				        		$( this ).dialog( "close" );
				        		$( this ).html('');
			      			}
			      		}
		      		]
			    };
			    let dlg = $('<div/>').html('<form>List<br><select name="inputListId"><option value="0">None</option></select></form>');
				DATA_LISTS.forEach(v=>{
					$(dlg).find('select[name="inputListId"]').append('<option '+(editValues && parseInt(editValues.list_id,10) === parseInt(v.id,10) ? 'selected ':'')+'value="'+v.id+'">'+v.name+'</option>');
				});
				let div_aktiv = $('<div/>');
				div_aktiv.html('<p><input name="inputActive" '+(!isPremium()?'disabled':'')+' type="checkbox" '+(editValues.aktiv === "1"?'checked':'')+'> is activ '+(!isPremium()?getLabelPremiumOnly():'')+'</p>');

				dlg.find("form").append(div_aktiv);
				dlg.dialog(_options);

				if (myAjax._isPremium) PREMIUM.addCodeMaskEditFields(dlg, editValues);

				let form = dlg.find("form").on("submit", function(event) {
					event.preventDefault();
					___submitForm();
				});
				function ___submitForm() {
					let inputListId = parseInt($(dlg).find('select[name="inputListId"]').val(),10);
					dlg.html(_getSpinnerHTML());
					let _data = {"list_id":inputListId, "aktiv":form[0].elements['inputActive'].checked ? 1 : 0};
					if (myAjax._isPremium) PREMIUM.addCodeMaskEditFieldsData(_data, form[0], editValues);
					form[0].reset();
					if (editValues) {
						_data.code = editValues.code;
						_makeGet('editCode', _data, function(result) {
							tabelle_codes_datatable.ajax.reload();
							closeDialog(dlg);
						}, function() {
							closeDialog(dlg);
						});
					} else {
						alert("use the add option");
					}
				}
			} // ende __showMaskCode

			DIV.html('');
			DIV.append(this.renderMainBody());

			let btn_liste_empty = $('<button/>').addClass("button-secondary").html("Empty table").on("click", function(){
				if (confirm("Do you want to empty the 'List of Codes' table? All data will be lost.")) {
					_makeGet('emptyTableLists', null, function(result){
						tabelle_codes_datatable.ajax.reload();
						__renderTabelleListen();
					});
				}
			});
			let btn_liste_new = $('<button/>').addClass("button-primary").html("Add").on("click", function(){
				__showMaskList(null);
			});
			this.div_liste.html($('<div/>').css('text-align', 'right').css('margin-bottom','10px').append(btn_liste_empty).append(isPremium()?'':' Max. '+myAjax._max.lists+' list. Unlimited with '+getLabelPremiumOnly()+' ').append(btn_liste_new));
			let tplace = $('<div/>');
			this.div_liste.append(tplace);

			let tabelle_liste_datatable;
			function __renderTabelleListen() {
				getDataLists(function(){
					let id_liste = myAjax.divPrefix+'_tabelle_liste';
					let tabelle_liste = $('<table/>').attr("id", id_liste);
					tabelle_liste.html('<thead><tr><th align="left">Name</th><th align="left">Created</th><th></th></tr></thead>');
					tplace.html(tabelle_liste);

					let table = $('#'+id_liste);
					$(table).DataTable().clear().destroy();
					tabelle_liste_datatable = $(table).DataTable({
						"visible": true,
						"searching": true,
		    			"ordering": true,
		    			"processing": true,
		    			"serverSide": false,
		    			"stateSave": true,
		    			"data": DATA_LISTS,
		    			"order": [[ 0, "asc" ]],
		    			"columns":[
		    				{"data":"name", "orderable":true},
		    				{"data":"time", "orderable":true},
		    				{"data":null,"orderable":false,"defaultContent":'',"className":"buttons dt-right",
		    					"render": function ( data, type, row ) {
		    						return '<button class="button-secondary" data-type="edit">Edit</button> <button class="button-secondary" data-type="delete">Delete</button>';
		                		}
		                	}
		    			]
					});
					table.on('click', 'button[data-type="edit"]', function (e) {
		        		let data = tabelle_liste_datatable.row( $(this).parents('tr') ).data();
		        		__showMaskList(data);
					});
					table.on('click', 'button[data-type="delete"]', function (e) {
		        		let data = tabelle_liste_datatable.row( $(this).parents('tr') ).data();
		        		LAYOUT.renderYesNo('Do you want to delete?', 'Are you sure, you want to delete this list?<br><p><b>'+data.name+'</b></p>No code will be deleted. Just the list.', function() {
		        			let _data = {'id':data.id};
		        			_makePost('removeList', _data, function(result) {
								__renderTabelleListen();
								tabelle_codes_datatable.ajax.reload();
							});
		        		});
					});
				}); // end of loading lists
			} // __renderTabelleListen
			__renderTabelleListen();


			let id_codes = myAjax.divPrefix+'_tabelle_codes';
			let tabelle_codes = $('<table/>').attr("id", id_codes);
			tabelle_codes.html('<thead><tr><th></th><th align="left">Code</th><th align="left">List</th><th align="left">Created</th><th>Status</th><th></th></tr></thead>');
			let btn_codes_new = $('<button/>').addClass("button-primary").html("Add").on("click", function(){
				LAYOUT.renderAddCodes();
			});
			let btn_codes_empty = $('<button/>').addClass("button-secondary").html("Empty table").on("click", function(){
				if (confirm("Do you want to empty the 'Codes' table? All data will be lost.")) {
					_makeGet('emptyTableCodes', null, function(result){
						tabelle_codes_datatable.ajax.reload();
					});
				}
			});
			let btn_codes_export = $('<button/>').addClass("button-secondary").html("Export table").on("click", function(){
				let url = _requestURL('exportTableCodes', null);
				window.open(url, "_blank");
			});

			this.div_codes.html($('<div/>').css('text-align', 'right').css('margin-bottom','10px').append(btn_codes_export).append(btn_codes_empty).append(isPremium()?'':' Max. '+myAjax._max.codes+' codes. Unlimited with '+getLabelPremiumOnly()+' ').append(btn_codes_new));
			this.div_codes.append(tabelle_codes);
			let tabelle_codes_datatable = $(this.div_codes).find('#'+id_codes).DataTable({
				"processing": true,
    			"serverSide": true,
    			"stateSave": false,
				"ajax": _requestURL('getCodes'),
    			"order": [[ 0, "asc" ]],
    			"columns":[
    				{"data":null,"className":'details-control',"orderable":false,"defaultContent":''},
    				{"data":"code_display", "orderable":true},
    				{"data":"list_name", "orderable":true},
    				{"data":"time", "orderable":true},
    				{"data":null, "orderable":true, "className":"dt-center", "render":function(data, type, row){
    					return data.aktiv === "1" ? "activ" : '<span style="color:red;">inactive</span>';
    				}},
    				{"data":null,"orderable":false,"defaultContent":'',"className":"buttons dt-right",
    					"render": function ( data, type, row ) {
    						return '<button class="button-secondary" data-type="edit">Edit</button> <button class="button-secondary" data-type="delete">Delete</button>';
                		}
                	}
    			]
			});
			tabelle_codes.on('click', 'button[data-type="edit"]', function (e) {
        		let data = tabelle_codes_datatable.row( $(this).parents('tr') ).data();
        		__showMaskCode(data);
			});
			tabelle_codes.on('click', 'button[data-type="delete"]', function (e) {
        		let data = tabelle_codes_datatable.row( $(this).parents('tr') ).data();
        		LAYOUT.renderYesNo('Do you want to delete?', 'Are you sure, you want to delete this code?<br><br><b>'+data.code+'</b>', function() {
        			let _data = {'code':data.code};
        			_makePost('removeCode', _data, function(result) {
						tabelle_codes_datatable.ajax.reload();
					});
        		});
			});
    		$('#'+id_codes+' tbody').on('click', 'td.details-control', function () {
    			function ___format(d) {
    				let div = $('<div/>');
					//let div1 = $('<div/>').addClass( 'loading' ).html( _getSpinnerHTML() );
					//div.append(div1);
					div.html('<b>Created:</b> '+d.time+'<br><b>Code:</b> '+d.code+'<br><b>Code Display:</b> '+d.code_display+'<br><b>Aktiv:</b> '+(parseInt(d.aktiv,10) === 1?'True':'False'));
					if (isPremium()) div.append(PREMIUM.displayCodeDetails(d, tabelle_codes_datatable));
					div.append("<h4>Registered user</h4>");
					if (isPremium())  div.append(PREMIUM.displayRegisteredUserForCode(d, tabelle_codes_datatable));
					else div.append(getLabelPremiumOnly());
					div.append("<h4>IP list checked for this code</h4>");
					if (isPremium()) {
						div.append(PREMIUM.displayTrackedIPsForCode(d.code));
					} else div.append(getLabelPremiumOnly());
    				return div;
            	}

        		var tr = $(this).closest('tr');
        		var row = tabelle_codes_datatable.row( tr );
        		if ( row.child.isShown() ) {
            		// This row is already open - close it
            		row.child.hide();
            		tr.removeClass('shown');
        		} else {
            		// Open this row
            		row.child( ___format(row.data()) ).show();
            		tr.addClass('shown');
        		}
			});
		} // render layout

		renderFatalError(content) {
			let _options = {
				title: 'Error',
		      	modal: true,
		      	minWidth: 400,
				minHeight: 200,
		      	buttons: [{text:'Ok', click:function(){
		      		$(this).dialog("close");
		      		$(this).html("");
		      	}}]
		    };
		    let dlg = $('<div/>').html(content);
			dlg.dialog(_options);
		}
		renderYesNo(title, content, cbfYes, cbfNo) {
			let _options = {
				title: title,
		      	modal: true,
		      	minWidth: 400,
				minHeight: 200,
		      	buttons: [{text:'Yes', click:function(){
		      		$(this).dialog("close");
		      		$(this).html("");
		      		cbfYes && cbfYes();
		      	}},{text:'No', click:function(){
		      		$(this).dialog("close");
		      		$(this).html("");
		      		cbfNo && cbfNo();
		      	}}]
		    };
		    let dlg = $('<div/>').html(content);
			dlg.dialog(_options);
		}
	}

	function addStyleCode(content) {
		let c = document.createElement('style');
		c.innerHTML = content;
		document.getElementsByTagName("head")[0].appendChild(c);
	}
	function addStyleTag(url, id, onloadfkt, attrListe, loadLatest) {
	  var script  = document.createElement('link');
	  script.type = 'text/css';
	  script.rel = "stylesheet";
	  let myId = id;
	  if (!myId) myId = url;
		if (document.getElementById(id) && document.getElementById(id).src === url) {
			onloadfkt && onloadfkt();
			return; // prevent re-adding the same tag
		}
	  script.id = id;
	  if (attrListe) for(var attr in attrListe) script.setAttribute(attr, attrListe[attr]);
	  script.href = url;
	  if (loadLatest) script.href += '?t='+new Date().getTime();
	  if (typeof onloadfkt !== "undefined") script.onload = onloadfkt;
	  document.getElementsByTagName("head")[0].appendChild(script);
	}

	function addScriptTag(url, id, onloadfkt, attrListe, loadLatest) {
	  	var head    = document.getElementsByTagName("head")[0];
	  	var script  = document.createElement('script');
	  	script.type = 'text/javascript';
	  	let myId = id;
	  	if (!myId) myId = url;
		if (document.getElementById(id) && document.getElementById(id).src === url) {
			onloadfkt && onloadfkt();
			return; // prevent re-adding the same tag
		}
	  script.id = id;
	  if (attrListe) for(var attr in attrListe) script.setAttribute(attr, attrListe[attr]);
	  script.src = url;
	  if (loadLatest) script.src += '?t='+new Date().getTime();
	  if (typeof onloadfkt !== "undefined") script.onload = onloadfkt;
	  head.appendChild(script);
	}

	function getLabelPremiumOnly() {
		return '[<a href="https://vollstart.de/serial-codes-validator-premium/">PREMIUM ONLY</a>]';
	}

	function _getSpinnerHTML() {
		return '<span class="lds-dual-ring"></span>';
	}

	function _loadingJSDatatables(cbf) {
		let loaded = {};
		addStyleCode('table.dataTable tr.shown td.details-control {background: url('+myAjax._plugin_home_url+'/img/details_close.png) no-repeat center center;}td.details-control {background: url('+myAjax._plugin_home_url+'/img/details_open.png) no-repeat center center;cursor: pointer;}');
		addStyleTag(myAjax._plugin_home_url+'/3rd/datatables.min.css', 'jquery_dataTables', function() {
			loaded['1'] = true;
			if (loaded['2']) {
				cbf && cbf();
			}
		}, {'crossorigin':"anonymous"});
		addScriptTag(myAjax._plugin_home_url+"/3rd/datatables.min.js", 'jquery_dataTables', function() {
			loaded['2'] = true;
			if (loaded['1']) {
				cbf && cbf();
			}
		}, {'crossorigin':"anonymous", "charset":"utf8"});
	}

	function isPremium() {
		return myAjax._isPremium == "1" || myAjax._isPremium === true;
	}

	function getHelperFunktions() {
		return {
			_getSpinnerHTML:_getSpinnerHTML,
			_makePost:_makePost,
			_makeGet:_makeGet,
			_requestURL:_requestURL,
			_getLAYOUT:function(){ return LAYOUT;},
			_getDIV:function(){ return DIV;}
		};
	}

	function init() {
		addStyleCode('.lds-dual-ring {display:inline-block;width:64px;height:64px;}.lds-dual-ring:after {content:" ";display:block;width:46px;height:46px;margin:1px;border-radius:50%;border:5px solid #fff;border-color:#2e74b5 transparent #2e74b5 transparent;animation:lds-dual-ring 0.6s linear infinite;}@keyframes lds-dual-ring {0% {transform: rotate(0deg);}100% {transform: rotate(360deg);}');

    	DIV = $('#'+myAjax.divId);
    	DIV.html(_getSpinnerHTML());
    	LAYOUT = new Layout();
		function _init() {
	 		_loadingJSDatatables(function() {
				LAYOUT.renderAdminPageLayout();
			});
		}

    	if (isPremium() && myAjax._premJS !== "") {
    		addScriptTag(myAjax._premJS, null, function() {
    			PREMIUM = new sngmbhSerialcodesValidatorPremium(myAjax, getHelperFunktions());
    			_init();
    		});
    	} else {
			_init();
    	}

	}

	init();
}
Ajax_sngmbhSerialcodesValidator && sngmbhSerialcodesValidator(Ajax_sngmbhSerialcodesValidator);