<?php
defined('ABSPATH') or die('Direct access not allowed');
if (is_admin() && isset($_REQUEST['SngmbhSerialcodesValidatorDebug'])) {
	defined('WP_DEBUG') or define( 'WP_DEBUG', true );
	ini_set('display_startup_errors', 'On');
	error_reporting(2147483647); // max future error values
	ini_set('display_errors', 'On');
}
class sngmbhSerialcodesValidator_AdminSettings {
	private $DB;
	private $BASE;

	public function __construct($BASE=null) {
		$this->BASE = $BASE;
    	include_once plugin_dir_path(__FILE__)."db.php";
    	$this->DB = new sngmbhSerialcodesValidatorDB();
	}
	public function plugin_uninstall(){
		//delete_option
		//delete tabellen
	}
	public function executeJSON($a, $data=[]) {
		$ret = "";
		$justJSON = false;
		try {
			switch (trim($a)) {
				case "getLists":
					$ret = $this->getLists();
					break;
				case "getList":
					$ret = $this->getList($data);
					break;
				case "addList":
					$ret = $this->addList($data);
					break;
				case "editList":
					$ret = $this->editList($data);
					break;
				case "removeList":
					$ret = $this->removeList($data);
					break;
				case "getCodes":
					$ret = $this->getCodes($data, $_REQUEST);
					$justJSON = true;
					break;
				case "addCode":
					$ret = $this->addCode($data);
					break;
				case "editCode":
					$ret = $this->editCode($data);
					break;
				case "removeCode":
					$ret = $this->removeCode($data);
					break;
				case "emptyTableLists":
					$ret = $this->emptyTableLists($data);
					break;
				case "emptyTableCodes":
					$ret = $this->emptyTableCodes($data);
					break;
				case "exportTableCodes":
					$ret = $this->exportTableCodes($data);
					break;
				case "premium":
					$ret = $this->executeJSONPremium($data);
					break;
				default:
					throw new Exception("function ".$a." not implemented");
			}
		} catch(Exception $e) {
			return wp_send_json_error ($e->getMessage());
		}
		if ($justJSON) return wp_send_json($ret);
		else return wp_send_json_success( $ret );
	}
	private function executeJSONPremium($data) {
		if (!$this->BASE->isPremium()) throw new Exception("#9001 premium is not active");
		if (!isset($data['c'])) throw new Exception("#9002 premium action is missing");
		return $this->BASE->getPremiumFunctions()->executeJSON($data['c'], $data);
	}

	private function getList($data) {
		if (!isset($data['id'])) throw new Exception("#104 id is missing");
		$sql = "select * from ".$this->DB->getTabelle("lists")." where id = ".intval($data['id']);
		$ret = $this->DB->_db_datenholen($sql);
		if (count($ret) == 0) throw new Exception("#105 not found");
		return $ret[0];
	}

	private function getLists() {
		$sql = "select * from ".$this->DB->getTabelle("lists");
		return $this->DB->_db_datenholen($sql);
	}

	private function addList($data) {
		if (!isset($data['name']) || trim($data['name']) == "") throw new Exception("#101 name missing");
		if (!$this->BASE->premiumCheck_isAllowedAddingList($this->DB->_db_getRecordCountOfTable('lists'))) throw new Exception("#108 too many codes. Unlimited codes only with premium");
		$felder = ["name"=>$data['name'], "aktiv"=>1, "time"=>date("Y-m-d H:i:s")];
		return $this->DB->insert("lists", $felder);
	}

	private function editList($data) {
		if (!isset($data['name']) || trim($data['name']) == "") throw new Exception("#102 name missing");
		if (!isset($data['id']) || intval($data['id']) == 0) throw new Exception("#103 id missing");
		$felder = ["name"=>$data['name']];
		$where = ["id"=>intval($data['id'])];
		return $this->DB->update("lists", $felder, $where);
	}

	private function removeList($data) {
		if (!isset($data['id'])) throw new Exception("#106 id is missing");
		$sql = "update ".$this->DB->getTabelle("codes")." set list_id = 0 where list_id = ".intval($data['id']);
		$this->DB->_db_query($sql);
		$sql = "delete from ".$this->DB->getTabelle("lists")." where id = ".intval($data['id']);
		return $this->DB->_db_query($sql);
	}

	private function clearCode($code) {
		return str_replace(" ","",str_replace(":","",str_replace("-", "", $code)));
	}
	private function retrieveCodeByCode($code, $mitListe=false) {
		$code = $this->clearCode($code);
		$code = $this->DB->reinigen_in($code);
		if (empty($code)) throw new Exception("#203 code empty");
		if ($mitListe) {
			$sql = "select a.*, b.name as list_name from ".$this->DB->getTabelle("codes")." a
					left join ".$this->DB->getTabelle("lists")." b on a.list_id = b.id
					where code = '".$code."'";
		} else {
			$sql = "select a.* from ".$this->DB->getTabelle("codes")." a where code = '".$code."'";
		}
		$ret = $this->DB->_db_datenholen($sql);
		if (count($ret) == 0) throw new Exception("#204 not found");
		return $ret[0];
	}
	private function getCode($data) {
		if (!isset($data['code']) || trim($data['code']) == "") throw new Exception("#202 code missing");
		return $this->retrieveCodeByCode($data['code'], true);
	}
	private function getCodes($data, $request) {
		$sql = "select a.*, b.name as list_name from ".$this->DB->getTabelle("codes")." a
				left join ".$this->DB->getTabelle("lists")." b on a.list_id = b.id";

		// für datatables
		$length = 0;
		if (isset($request['length'])) $length = intval($request['length']);
		$draw = 1; // sequenz zähler, also fortlaufend für jede aktion auf der JS datentabelle
		if (isset($request['draw'])) $draw = intval($request['draw']);
		$start = 0;
		if (isset($request['start'])) $start = intval($request['start']);
		$order_column = "code";
		if (isset($request['order'])) $order_column = array('','code','list_name','time','aktiv')[intval($request['order'][0]['column'])];
		$order_dir = "asc";
		if (isset($request['order']) && $request['order'][0]['dir'] == 'desc') $order_dir = "desc";
		$search = "";
		if (isset($request['search'])) $search = $this->DB->reinigen_in($request['search']['value']);

		$where = "";
		if ($search != "") {
			$sql .= " where ";
			$sql .= " a.code like '%".$this->clearCode($search)."%' or b.name like '%".$search."%' or a.time like '%".$search."%' ";
			$where .= " a.code like '%".$this->clearCode($search)."%' or b.name like '%".$search."%' or a.time like '%".$search."%' ";
		}
		if ($order_column != "") $sql .= " order by ".$order_column." ".$order_dir;
		if ($length > 0)
			$sql .= " limit ".$start.", ".$length;

		$daten = $this->DB->_db_datenholen($sql);
		$recordsTotal = $this->DB->_db_getRecordCountOfTable('codes');
		$recordsTotalFilter = $recordsTotal;
		if (!empty($where)) {
			$sql = "select count(a.id) as anzahl
					from
					".$this->DB->getTabelle("codes")." a,
					".$this->DB->getTabelle("lists")." b
					where ".$where;
			list($d) = $this->DB->_db_datenholen($sql);
			$recordsTotalFilter = $d['anzahl'];
		}

		return ["draw"=>$draw,
				"recordsTotal"=>intval($recordsTotal),
				"recordsFiltered"=>intval($recordsTotalFilter),
				"data"=>$daten];
	}
	private function addCode($data) {
		if (!isset($data['code']) || trim($data['code']) == "") throw new Exception("#201 code missing");
		if (!$this->BASE->premiumCheck_isAllowedAddingCode($this->DB->_db_getRecordCountOfTable('codes'))) throw new Exception("#208 too many codes. Unlimited codes only with premium");
		$code = $this->clearCode($data['code']);
		// check ob schon existiert
		try {
			$this->retrieveCodeByCode($code, false);
		} catch(Exception $e) { // not found -> gut
			// speichern
			$list_id = isset($data['list_id']) ? intval($data['list_id']) : 0;
			$felder = ["code"=>$code, "code_display"=>$data['code'], "aktiv"=>1, "time"=>date("Y-m-d H:i:s"), "meta"=>"", "list_id"=>$list_id];
			return $this->DB->insert("codes", $felder);
		}
		throw new Exception("#205 code exists already");
	}
	private function editCode($data) {
		if (!isset($data['code']) || trim($data['code']) == "") throw new Exception("#206 code missing");
		$data['code'] = $this->clearCode($data['code']);
		$codeObj = $this->retrieveCodeByCode($data['code']);
		$felder = [];
		if (isset($data['list_id'])) $felder['list_id'] = intval($data['list_id']);
		if ($this->BASE->isPremium()) $felder = $this->BASE->getPremiumFunctions()->setFelderCodeEdit($felder, $data, $codeObj);
		if (isset($data['code_display'])) $felder['code_display'] = intval($data['code_display']);
		if (count($felder) > 0) {
			$where = ["code"=>$this->DB->reinigen_in($data['code'])];
			return $this->DB->update("codes", $felder, $where);
		}
		return "nothing to update";
	}
	private function removeCode($data) {
		if (!isset($data['code'])) throw new Exception("#207 code is missing");
		$data['code'] = $this->clearCode($data['code']);
		$sql = "delete from ".$this->DB->getTabelle("codes")." where code = '".$this->DB->reinigen_in($data['code'])."'";
		return $this->DB->_db_query($sql);
	}
	private function emptyTableLists($data) {
		$sql = "update ".$this->DB->getTabelle("codes")." set list_id = 0";
		$this->DB->_db_query($sql);
		$sql = "delete from ".$this->DB->getTabelle("lists");
		return $this->DB->_db_query($sql);
	}
	private function emptyTableCodes($data) {
		$sql = "delete from ".$this->DB->getTabelle("codes");
		return $this->DB->_db_query($sql);
	}
	private function exportTableCodes($data) {
		set_time_limit(0);
		// hole daten
		$sql = "select a.*, b.name as list_name from ".$this->DB->getTabelle("codes")." a left join ".$this->DB->getTabelle("lists")." b on a.list_id = b.id";
		$daten = $this->DB->_db_datenholen($sql);
		// sende csv datei
		$filename = "export_codes_sngmbhSerialcodesValidator_".date("YmdHis").".csv";
		$this->_basics_sendeDateiCSVvonDBdaten($daten, $filename);
		exit;
	}
	private function _basics_sendeDateiCSVvonDBdaten($daten, $filename, $delimiter=";") {
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Content-Description: File Transfer');
        header('Content-type: text/csv');
    	header('Content-Disposition: attachment; filename="'.$filename.'"');
        header('Expires: 0');
        header('Pragma: public');

		ob_end_clean();
		$out = fopen('php://output', 'w');

		if (count($daten) > 0) {
			fputcsv($out, array_keys($daten[0]), $delimiter);
			foreach($daten as $value) {
				fputcsv($out, array_values($value), $delimiter);
			}
		} else {
			fputcsv($out, array("no data"), $delimiter);
		}
		fclose($out);
	}
}
?>