<?php
defined('ABSPATH') or die('Direct access not allowed');
if (is_admin() && isset($_REQUEST['SngmbhSerialcodesValidatorDebug'])) {
	defined('WP_DEBUG') or define( 'WP_DEBUG', true );
	ini_set('display_startup_errors', 'On');
	error_reporting(2147483647); // max future error values
	ini_set('display_errors', 'On');
}
class sngmbhSerialcodesValidator_Frontend {
	private $DB;
	private $BASE;

	public function __construct($BASE=null) {
		$this->BASE = $BASE;
    	include_once plugin_dir_path(__FILE__)."db.php";
    	$this->DB = new sngmbhSerialcodesValidatorDB();
	}

	public function executeJSON($a, $data=[]) {
		$ret = "";
		$justJSON = false;
		try {
			switch (trim($a)) {
				case "checkCode":
					$ret = $this->checkCode($data);
					break;
				case "premium":
					$ret = $this->executeJSONPremium($data);
					break;
				default:
					throw new Exception("function ".$a." not implemented");
			}
		} catch(Exception $e) {
			return wp_send_json_error (['msg'=>$e->getMessage()]);
		}
		if ($justJSON) return wp_send_json($ret);
		else return wp_send_json_success( $ret );
	}

	private function executeJSONPremium($data) {
		if (!$this->BASE->isPremium()) throw new Exception("#9001 premium is not active");
		if (!isset($data['d'])) throw new Exception("#9002 premium action is missing");
		return $this->BASE->getPremiumFunctions()->executeFrontendJSON($data['d'], $data);
	}

	private function clearCode($code) {
		return str_replace(" ","",str_replace(":","",str_replace("-", "", $code)));
	}
	private function retrieveCodeByCode($code, $mitListe=false) {
		$code = $this->clearCode($code);
		$code = $this->DB->reinigen_in($code);
		if (empty($code)) throw new Exception("#203 code empty");
		if ($mitListe) {
			$sql = "select a.*, b.name as list_name from ".$this->DB->getTabelle("codes")." a
					left join ".$this->DB->getTabelle("lists")." b on a.list_id = b.id
					where code = '".$code."'";
		} else {
			$sql = "select * from ".$this->DB->getTabelle("codes")."  where code = '".$code."'";
		}
		$ret = $this->DB->_db_datenholen($sql);
		if (count($ret) == 0) throw new Exception("#204 not found");
		return $ret[0];
	}
	private function checkCode($data) {
		if (!isset($data['code']) || trim($data['code']) == "") throw new Exception("#1001 code missing");
		if ($this->BASE->isPremium()) $data = $this->BASE->getPremiumFunctions()->beforeCheckCode($data);
		$valid = 1;
		try {
			$codeObj = $this->retrieveCodeByCode($data['code'], false);
			if ($codeObj['aktiv'] != 1) $valid = 2;
			if ($codeObj['aktiv'] == 1 && $this->BASE->isPremium()) {
				if($this->BASE->getPremiumFunctions()->isCodeExpired($codeObj)){
					$valid = 4;
				} else if($this->BASE->getPremiumFunctions()->isCodeIsRegistered($codeObj)){
					$valid = 3;
				}
			}
		} catch (Exception $e) {
			$valid = 0;
		}
		$codeObj['_valid'] = $valid;
		if ($this->BASE->isPremium()) $codeObj = $this->BASE->getPremiumFunctions()->afterCheckCode($codeObj);
		return ['valid'=>$codeObj['_valid']];
	}
}
?>